com.fasterxml.jackson.databind.ser.impl

## Class IteratorSerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<T>
    - - com.fasterxml.jackson.databind.ser.ContainerSerializer<T>
      - - com.fasterxml.jackson.databind.ser.std.AsArraySerializerBase<Iterator<?>>
        - - com.fasterxml.jackson.databind.ser.impl.IteratorSerializer

All Implemented Interfaces:
  JsonFormatVisitable, SchemaAware, ContextualSerializer, Serializable

    public class IteratorSerializer
    extends AsArraySerializerBase<Iterator<?>>

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

`JsonSerializer.None`

### Field Summary

### Fields inherited from class com.fasterxml.jackson.databind.ser.std.AsArraySerializerBase

`_dynamicSerializers, _elementSerializer, _elementType, _property, _staticTyping, _unwrapSingle, _valueTypeSerializer`

### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`_handledType`

### Constructor Summary

Constructors
Constructor and Description
`IteratorSerializer(IteratorSerializer src, BeanProperty property, TypeSerializer vts, JsonSerializer<?> valueSerializer, Boolean unwrapSingle)`
`IteratorSerializer(JavaType elemType, boolean staticTyping, TypeSerializer vts)`

### Method Summary

Methods
`ContainerSerializer<?>` `_withValueTypeSerializer(TypeSerializer vts)` Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.
`boolean` `hasSingleElement(Iterator<?> value)` Method called to determine if the given value (of type handled by this serializer) contains exactly one element.
`boolean` `isEmpty(SerializerProvider prov, Iterator<?> value)` Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).
`void` `serialize(Iterator<?> value, JsonGenerator gen, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
`void` `serializeContents(Iterator<?> value, JsonGenerator gen, SerializerProvider provider)`
`IteratorSerializer` `withResolved(BeanProperty property, TypeSerializer vts, JsonSerializer<?> elementSerializer, Boolean unwrapSingle)`

### Methods inherited from class com.fasterxml.jackson.databind.ser.std.AsArraySerializerBase

`_findAndAddDynamic, _findAndAddDynamic, acceptJsonFormatVisitor, createContextual, getContentSerializer, getContentType, getSchema, serializeWithType, withResolved`

### Methods inherited from class com.fasterxml.jackson.databind.ser.ContainerSerializer

`hasContentTypeAnnotation, isEmpty, withValueTypeSerializer`

### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`createObjectNode, createSchemaNode, createSchemaNode, findAnnotatedContentSerializer, findConvertingContentSerializer, findFormatFeature, findFormatOverrides, findPropertyFilter, getSchema, handledType, isDefaultSerializer, visitArrayFormat, visitArrayFormat, visitFloatFormat, visitIntFormat, visitIntFormat, visitStringFormat, visitStringFormat, wrapAndThrow, wrapAndThrow`

### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

`getDelegatee, isUnwrappingSerializer, properties, replaceDelegatee, unwrappingSerializer, usesObjectId, withFilterId`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### IteratorSerializer

    public IteratorSerializer(JavaType elemType,
                      boolean staticTyping,
                      TypeSerializer vts)

#### IteratorSerializer

    public IteratorSerializer(IteratorSerializer src,
                      BeanProperty property,
                      TypeSerializer vts,
                      JsonSerializer<?> valueSerializer,
                      Boolean unwrapSingle)

### Method Detail

#### isEmpty

    public boolean isEmpty(SerializerProvider prov,
                  Iterator<?> value)

Description copied from class: `JsonSerializer`
Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

Default implementation will consider only null values to be empty.

NOTE: replaces `JsonSerializer.isEmpty(Object)`, deprecated in 2.5

Overrides:
  `isEmpty` in class `JsonSerializer<Iterator<?>>`

#### hasSingleElement

    public boolean hasSingleElement(Iterator<?> value)

Description copied from class: `ContainerSerializer`
Method called to determine if the given value (of type handled by this serializer) contains exactly one element.

Note: although it might seem sensible to instead define something like "getElementCount()" method, this would not work well for containers that do not keep track of size (like linked lists may not).

Specified by:
  `hasSingleElement` in class `ContainerSerializer<Iterator<?>>`

#### _withValueTypeSerializer

    public ContainerSerializer<?> _withValueTypeSerializer(TypeSerializer vts)

Description copied from class: `ContainerSerializer`
Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.

Specified by:
  `_withValueTypeSerializer` in class `ContainerSerializer<Iterator<?>>`

#### withResolved

    public IteratorSerializer withResolved(BeanProperty property,
                                  TypeSerializer vts,
                                  JsonSerializer<?> elementSerializer,
                                  Boolean unwrapSingle)

Specified by:
  `withResolved` in class `AsArraySerializerBase<Iterator<?>>`

#### serialize

    public final void serialize(Iterator<?> value,
                 JsonGenerator gen,
                 SerializerProvider provider)
                         throws IOException

Description copied from class: `JsonSerializer`
Method that can be called to ask implementation to serialize values of type this serializer handles.

Overrides:
  `serialize` in class `AsArraySerializerBase<Iterator<?>>`
Parameters:
  `value` - Value to serialize; can not be null.
  `gen` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
Throws:
  `IOException`

#### serializeContents

    public void serializeContents(Iterator<?> value,
                         JsonGenerator gen,
                         SerializerProvider provider)
                           throws IOException

Specified by:
  `serializeContents` in class `AsArraySerializerBase<Iterator<?>>`
Throws:
  `IOException`